# -*- coding: Latin-1 -*-

##############################################################################
#
# LICENSE:
# This code is bound to be ugly, have mistakes,
# and generally just be plain _wrong_.
#
# What do you care though?  It works, and you
# got it for free. ;-)  Feel free to make any
# changes and re-releases.
#
# Additionally it complies with the terms of the Zope Public License,
# Version 2.0 (ZPL)
#
##############################################################################
__doc__ = """Assistant classes for O2DB by (-:fs)"""
__version__ = '$Revision: 0.5.7 $'[11:-2]

from AccessControl import ClassSecurityInfo, Role
from Globals import InitializeClass, DTMLFile
from OFS.SimpleItem import SimpleItem, Item
from OFS.PropertyManager import PropertyManager
from OFS.ObjectManager import BeforeDeleteException
from OFS.FindSupport import FindSupport
from OFS.Folder import Folder

from o2dbMain import *
from o2dbSearch import *
from o2dbConnBroker import *


## -----------------------------------------------------------------------------
## -------------------------------- Functions --------------------------------
## -----------------------------------------------------------------------------
def getCB():
    return CB

def testDBconnection():
    SI = SearchInterface(CB)
    SAlist = [SearchAttribute(CB, "CHAR", "objectcategory", equal="foo and bar")]
    dummyResult = SI.searchObjects(SAlist)
    
def initDBconnection():  
    global CB, SI
    try:
        CB = ConnectionBroker(CBC, "mySQL", "zopeObjects")
        SI = SearchInterface(CB)
        SAlist = [SearchAttribute(CB, "CHAR", "objectcategory", equal="foo and bar")]
        dummyResult = SI.searchObjects(SAlist)
    except:
        CB = None; SI = None


CBC = ConnectionBrokerChief()
initDBconnection()


## -----------------------------------------------------------------------------
## -------------------------------  O2DB Folder  -------------------------------
## -----------------------------------------------------------------------------
manage_addO2DBFolderForm = DTMLFile('dtml/manage_addO2DBFolderForm', globals())
def manage_addO2DBFolder(self, id, title='', REQUEST=None):
    """add O2DB folder"""
    obj = O2DBFolder(id, title)
    self._setObject(id, obj)
    if REQUEST is not None:
        return self.manage_main(self, REQUEST)

class O2DBFolder(Folder):
    """O2DB Folder"""
    security = ClassSecurityInfo()
    meta_type = 'O2DB Folder'
    meta_types = [{'name': "Book",
                   'action': 'manage_addProduct/O2DB/manage_addBookForm',
                   'permission': 'blah blah - nobody cares'},
                  {'name': "Contact",
                   'action': 'manage_addProduct/O2DB/manage_addContactForm'},
                  {'name': "Sound Carrier",
                   'action': 'manage_addProduct/O2DB/manage_addSoundCarrierForm'},
                  {'name': "O2DB Folder",
                   'action': 'manage_addProduct/O2DB/manage_addO2DBFolderForm'} ]

    isAnObjectManager=1
    isPrincipiaFolderish=1

    manage_options = (
        (
          {'label':'Contents', 'action':'manage_main',
           'help':('O2DB','O2DBFolder.stx')},
          {'label': 'Search', 'action': 'manage_searchForm',
           'help':('O2DB','O2DBFolder.stx')},
          {'label': 'DB Connection', 'action': 'manage_DBconnection',
           'help':('O2DB','O2DBFolder.stx')},
        ) +
        Role.RoleManager.manage_options +
        Item.manage_options +
        FindSupport.manage_options)
    
    
    def __init__(self, id, title=''):
        self.id = id
        self.title = title

    #security.declareProtected('View management screens', 'manage_main')
    manage_main = DTMLFile('dtml/manage_main', globals())
    #security.declareProtected('View management screens', 'manage_search')
    manage_searchForm = DTMLFile('dtml/manage_searchForm', globals())
    #security.declareProtected('View management screens', 'manage_search')
    manage_searchResultForm = DTMLFile('dtml/manage_searchResultForm', globals())
    #security.declareProtected('View management screens', 'manage_search')
    manage_DBconnectionForm = DTMLFile('dtml/manage_DBconnectionForm', globals())

    #security.declareProtected('View management screens', 'manage_DBconnection')
    def manage_DBconnection(self, REQUEST=None):
        """ manage DB connection"""
        if REQUEST is not None:
            try:
                testDBconnection()
                REQUEST.set('DB_connection', "ACTIVE")
            except AttributeError:
                global CB, SI
                initDBconnection()
                if not (CB or SI):
                    REQUEST.set('DB_connection', "BROKEN")
                else:
                    REQUEST.set('DB_connection', "ACTIVE")

        return self.manage_DBconnectionForm(self, REQUEST)
    
    def all_meta_types(self):
        """ get all meta types addable to this folder The ZMI uses
            this method (original defined in ObjectManager) """
        return self.meta_types

    def cb_isMoveable(self):
        return 0

    def manage_beforeDelete(self, item, container):
        if item.objectValues():
            errValue = "O2DB Folder '" + self.getId() + \
                       "' is not empty and cannot be deleted. " + \
                       "Deletion request could also have been triggered by cut/paste or rename!"
            raise BeforeDeleteException, errValue

    def manage_afterClone(self, container):
        """ after O2DB folder is cloned, delete cloned objects (which point to
            already used external O2DB objects), clone zope objects _and_
            external objects and set them into folder
        """
        objList = self.objectValues()
        for obj in objList:
            newObj = obj._getCopy(self)
            self._delObject(obj.getId(), deleteExtObj=0)
            self._setObject(newObj.getId(), newObj)
        
            
    def _delObject(self, id, dp=1, deleteExtObj=1):
        """ one object is deleted from O2DB folder except switch
            'deleteExtObj' is set to zero from manage_afterClone !!!
            in manage_beforeDelete O2DB objects erase their external data
            TODO - raise error in NotSoSimpleItem when deletion fails
        """ 
        object=self._getOb(id, dp)     
        if deleteExtObj:    
            try:
                object.manage_beforeDelete(object, self)
            except BeforeDeleteException, ob:
                raise
            except:
                LOG('Zope',ERROR,'manage_beforeDelete() threw',
                    error=sys.exc_info())
                pass
            
        self._objects=tuple(filter(lambda i,n=id: i['id']!=n, self._objects))
        self._delOb(id)

        try:    object._v__object_deleted__ = 1
        except: pass

                     
    #security.declareProtected('View management screens', 'manage_search')
    def manage_search(self, obj_metatypes=[], attr_name='', attr_value='',
                      compare_type='', REQUEST=None):
        """search O2DB objects in external DB"""
        
        if REQUEST is not None:
            return self.manage_searchResultForm(self, REQUEST)

    def O2DBsearch(self, obj, obj_metatypes=[], attr_name=None,
                   attr_value=None, compare_type='', REQUEST=None):
        """searching in O2DB folder"""
        objectList = []; zopeObjectList = []

        for metatype in obj_metatypes:
            foundObjects = self._search(metatype, attr_name, attr_value, compare_type)
            ## diese komischen tupel-results von der mysqldb rckgabe umwandeln
            if foundObjects:
                for i in range(len(foundObjects)):
                    objectList.append(foundObjects[i][0])   
       
            return self._getZopeObjects(objectList)
        
                      
    def _search(self, metatype, name, value, compare):
        """O2DB Search Interface"""
        SAlist = []
        
        if metatype != 'all':
            SA = SearchAttribute(CB, "CHAR", "objectcategory", equal=metatype)
            SAlist.append(SA)

        if name and value:
            if compare == "EQUAL":
                SA = SearchAttribute(CB, "CHAR", name, equal=value)
                SAlist.append(SA)
                return SI.searchObjects(SAlist)

            if compare == "LIKE":
                SA = SearchAttribute(CB, "CHAR", name, like=value)
                SAlist.append(SA)
                return SI.searchObjects(SAlist)

            if compare == "SUBSTRING":
                SA = SearchAttribute(CB, "CHAR", name, substring=value)
                SAlist.append(SA)
                return SI.searchSUBSTRING(SAlist)
            
        return []

    def _getZopeObjects(self, objIDs):
        """ build from objectcategory and ID of external obj the zopeID
            and return the zope objects
        """
        zope_ids = []
        
        for extID in objIDs:
            # build zope ids and append to list for ZopeFind
            extObj = PersistentObject(CB, extID)
            objCat = extObj.getAttributeValue("objectcategory")

            # sound carrier objects carry their type in the zopeID
            # e.g. LP, CD, ...
            if objCat == "Sound Carrier":
                zopeID = extObj.getAttributeValue("Type") + ' - ' + str(extID)
            else:
                zopeID = objCat + ' - ' + str(extID)

            zope_ids.append(zopeID)

        return FindSupport.ZopeFind(self, self, obj_ids=zope_ids, search_sub=1)
    
        
InitializeClass(O2DBFolder)


## -----------------------------------------------------------------------------
## ---------------------------------  Common  ----------------------------------
## -----------------------------------------------------------------------------
class NotSoSimpleItem(SimpleItem):

    def manage_beforeDelete(self, item, container):
        extObj = PersistentObject(CB, item.extObjID)
        extObj.deleteDBobject()
        extObj = None
        
    def _getCopy(self, container):      
        newExtID = self._cloneExternalObject(self.getProperty("extObjID"))
                                               
        newZopeObj = SimpleItem._getCopy(self, container)
        newZopeObj._setPropValue("extObjID", newExtID)                   
        newZopeObj._setId(self.getId().split(' - ')[0] + " - " + newExtID)

        return newZopeObj    

    def _cloneExternalObject(self, extID):
        """
        clone the object from external DB and return the newID
        """
        extObj = PersistentObject(CB, extID)

        newObj = PersistentObject(CB)
        for attr in extObj.getAttributes():
            type, name, value = attr
            newObj.addAttribute(type, name, value)
        newObj.save()

        return newObj.getID()


class O2DBbase(NotSoSimpleItem, PropertyManager):
 
    _properties = PropertyManager._properties + (
        {'id': 'extObjID',
         'type': 'int',
         'mode': 'r'}, )
    
    def __init__(self, id, title, externalObjectID):
        self.id = id
        self.title = title
        self.extObjID = externalObjectID
            
    def save_message(self):
        return "Successfully saved"
    
##    def cb_isMoveable(self):
##        return 0
